package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxBasic;
import org.flixel.FlxTilemap;
import org.flixel.FlxObject;
import org.flixel.FlxSound;
import nme.Assets;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Elastic;



class EndLevel extends BaseLevel
{
	public var instruction:FlxText;
	private var dialog1:Int;
	private var endTaco:FlxSprite;
	private var robotAwake:Bool;
	private var endTacoHit:Bool;
	private var talk2Over:Bool;

	private var tacoWants:FlxSound;
	private var comeTo:FlxSound;
	private var forever:FlxSound;
	private var chomp:FlxSound;
	private var bgArray:Array<Dynamic>;
	private var backGround2:FlxSprite;

	public function new()
	{
		super();
	}
	
	
	override public function create():Void
	{
		
		bgArray = new Array<Dynamic>();
		bgArray[0]=FlxAssets.endBg;
		bgArray[1]=FlxAssets.menuBg;
		bgArray[2]=FlxAssets.bgImage2;
		bgArray[3]=FlxAssets.bgImage3;
		bgArray[4]=FlxAssets.bgImage4;

		//sound stuff
		tacoWants = FlxG.loadSound(Assets.getSound ("assets/sounds/tacoWantsRobot.mp3"),1,false);
		comeTo = FlxG.loadSound(Assets.getSound ("assets/sounds/comeToTaco.mp3"),1,false);
		forever =FlxG.loadSound(Assets.getSound ("assets/sounds/togetherForever.mp3"),1,false);
		chomp =FlxG.loadSound(Assets.getSound ("assets/sounds/Chomp.mp3"),.75,false);


		backGround = new FlxSprite(0,0);
		backGround.alpha = 1;
		backGround.loadGraphic(FlxAssets.endBg,false,false,800,600);
		add(backGround);

		map = new FlxTilemap();
		map.loadMap(Assets.getText("assets/mapCSV_Group1_endScreen.csv"),FlxAssets.tileImg,20,20,FlxTilemap.OFF);
		add(map);


		endTaco = new FlxSprite(358,284);
		endTaco.loadGraphic(FlxAssets.lastTaco,true,false,88,45);
		endTaco.addAnimation("makeEyes",[1,2,3,3,3,3,2],16,false);
		endTaco.addAnimation("talk1",[1,2,3,4,3,2,1,1,2,2,3,4,3,3,2,1,5,5,1,2,3,4,3,2,2,2,1],16,false);
		endTaco.addAnimation("talk2",[1,1,1,2,3,4,3,2,1,5,5,1,2,3,4,3,2,2,2,1],16,false);
		endTaco.addAnimation("eat",[4,4,4,4,4,3,2,1,5,5,5,5,5,5,1,1,1,1,2,3,4,3,2,1,1,2,2,3,3,4,3,2,1,2,2,2,3,3,3,4,4,3,2,1,2,3,4,4,4,3,3,2,2,1],16,false);
		endTaco.addAnimationCallback(animationHandler);
		//endTaco.play("makeEyes");
		add(endTaco);

		super.create();

		stars.x = taco.x;
		stars.y = taco.y-6;
		stars.visible=false;
		ourPlayer.x=90;
		ourPlayer.y=550;
		endTacoHit = false;
		talk2Over = false;



        dialog1 = 0;
		instruction = new FlxText(200,240,400, "TACO WANTS ROBOT");
		instruction.setFont("assets/bithigh");
		instruction.size = 24;
		instruction.alpha=0;
		instruction.alignment = "center";
		add(instruction);

		
	
		taco.visible=false;
		robotAwake=false;

		levelInfo.visible=false;
		
	}

	public function animationHandler(name:String, currentFrame:Int, currentFrameIndex:Int){
		if(name=="talk1"&&endTaco.finished){
			Actuate.update (instruction.setAlpha, .25, [1],[0]).onComplete(switchText,[1]);
			Actuate.update (instruction.setAlpha, .25, [0],[1]).delay(.5);
		}
		else if(name=="talk2"&&endTaco.finished){
			instruction.text="";
			talk2Over=true;
			haxe.Timer.delay(callback(switchText,2),500); 
			Actuate.update (instruction.setAlpha, .25, [1],[0]);
		}
		

	}

	public function switchText(t:Int){
		if(t==1){
			instruction.text="COME TO TACO";
			comeTo.play();
			endTaco.play("talk2");
		}
		if(t==2){
			instruction.text="AND LET US BE TOGETHER FOREVER";
		}

	}


	override public function nextLevel():Void{
		if(FlxAssets.gameMode==2){
			lifeText.kill();
			lifeIcon.kill();
		}

		if(FlxAssets.gameMode==2){
				if(FlxAssets.saveGame.bind("RobotWants")){
					if(FlxAssets.saveGame.data.hotLevel==null){
						FlxAssets.saveGame.data.hotLevel=FlxAssets.level;
						FlxAssets.saveGame.close();
					}
					else if (FlxAssets.level>FlxAssets.saveGame.data.hotLevel) {
						FlxAssets.saveGame.data.hotLevel=FlxAssets.level;	
						FlxAssets.saveGame.close();
					}
				}
		}
		

		if (FlxAssets.gameMode==1) {
			//save game nonsense
			if(FlxAssets.saveGame.bind("RobotWants")){
					if(FlxAssets.saveGame.data.mildScore==null){
						FlxAssets.saveGame.data.mildScore=FlxAssets.totalTacos;
						FlxAssets.saveGame.data.mildHighLevel = FlxAssets.level;
					}
					else if (FlxAssets.totalTacos>FlxAssets.saveGame.data.mildScore) {
						FlxAssets.saveGame.data.mildScore=FlxAssets.totalTacos;	
						FlxAssets.saveGame.data.mildHighLevel = FlxAssets.level;	
					}

					//if (FlxAssets.level>FlxAssets.saveGame.data.ourLevel) {
						//FlxAssets.saveGame.data.ourLevel++;	
						//FlxAssets.saveGame.close();
					//}
					FlxAssets.saveGame.data.ourLevel = 0;
					FlxAssets.saveGame.data.currentGameScore=0;
					FlxAssets.saveGame.close();


			}
		}

		FlxAssets.totalTacos = 0;	
		FlxAssets.level=0;
		FlxAssets.gameMode=0;
		FlxG.switchState(new MenuLevel());
	}
	


	private function swapText(){
		    instruction.text = "PRESS X AGAIN TO SWAP CONTROL";
			Actuate.update (instruction.setAlpha, 1, [0],[1]);
			dialog1=1;
		
	}

	public function resetTime(){
			Actuate.update (instruction.setAlpha, .25, [1],[0]);
			instruction.scale.x=1;
			instruction.scale.y=1;
			instruction.text = "THE END";
			Actuate.tween(instruction.scale,2,{x:2,y:2});
			Actuate.update (instruction.setAlpha, .25, [0],[1]).delay(.5);
			haxe.Timer.delay(callback(nextLevel), 2500); 
	}

	public function playForever(){
		forever.play();
	}

	
	override public function update():Void
	{
		super.update();
		//instruction.x = ourPlayer.x-55;
		//instruction.y = ourPlayer.y-52;

		//if(robotAwake){
			backGround.loadGraphic(bgArray[FlxG.randomRange2(5,0)],false,false,800,600);
			backGround.alpha = FlxG.randomRange(4,1)*.1;

			//backGround2.loadGraphic(bgArray[FlxG.randomRange2(5,0)],false,false,800,600);
			//backGround2.alpha = FlxG.randomRange(8,1)*.1;
		//}

		if(ourPlayer.x>250&&!robotAwake){
			robotAwake=true;
			endTaco.play("talk1");
			tacoWants.play();
			Actuate.update (instruction.setAlpha, 2, [0],[1]);
		}

		if(FlxG.overlap(ourPlayer,endTaco)){
			if(!endTacoHit&&talk2Over){
				Actuate.update (instruction.setAlpha, .5, [0],[1]).delay(1);
				//Actuate.tween(endTaco,4,{scale.x:10,scale.y:10});
				endTaco.play("eat");
				Actuate.tween(endTaco.scale,20,{x:36,y:36});
				Actuate.tween(ourPlayer.scale,2,{x:0,y:0});
				Actuate.tween(instruction.scale,16,{x:2.5,y:2.5}).delay(1);
				Actuate.tween(endTaco,6,{y:80});
				Actuate.tween(ourPlayer,1,{x:390});
				endTacoHit=true;
				chomp.play();
			    haxe.Timer.delay(callback(playForever), 1000); 



				Actuate.update (overlay.setAlpha, 4, [0],[1])
				.delay(1)
				.onComplete(resetTime);


			}
			
		}




		
		FlxG.collide(lazerGroup,enemyGroup,enemyHit);
		FlxG.collide(lazerGroup,map,mapZap);
		updateParts();

	}//end of update

}