package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxU;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxObject;


class Enemy4 extends Enemy
{
	//This is for our messages
	private var topText:FlxText;
	public var jump:Float;
	public var onGround:Bool;
	public var ourSpeed:Float;
	public var stillTime:Float;
	public var control:Bool;
	public var speed:Int;

	public var oX:Float;
	public var oY:Float;
	public var radius:Float;
	public var sAngle:Float;
		
	public var rad:Float;
	public var radSpeed:Int;

	private var myPi:Float;
	public var vDir:Int;
	public var parent:BaseLevel;

	public var viewDist:Int;

	public var modeCoolDown:Float;
	public var shootCount:Int;



	
	override public function new(X:Float, Y:Float,P:BaseLevel,D:Int=1)
	{
		
		super(X,Y);
		loadGraphic(FlxAssets.flyguy2,true,true,36,18);

		oX = X;
		oY= Y;
		radius = 75;
		sAngle = 10;
		rad = 200;
		radSpeed = 1500;
		myPi = (Math.PI/ 180);
		vDir = D;
		viewDist = 150;

		parent = P;

		// 1 = normal , 2 = seeing
		mode = 1;
		modeCoolDown = 0;
		type=4;
		shootCount=0;
	
		//width = 12;
		//height = 12;
		//this.offset.x=2;
		//this.offset.y=1;
		//this.offset.x=6;
		//offset.y=-2;
		//stillTime = 0;


		if (vDir==1) 
		{
			speed = 45;
		}
		else{
			speed = -45;	
		}



		//acceleration.y=1100;
		maxVelocity.y = 350;

		//addAnimation("normal",[6,4,5,4,6,4,5,4,6,4,5,4,6,4,5,4,6,4,5,4,6,4,5,4,6,4,5,4,0,1,2,1,0,1,2,1,0,1,2,1,0,1,2,1,6,4,5,4,6,4,5,4,0,1,2,1],12);
		addAnimation("normal",[0,0,1,2,3,4,3,2,1],18);
		addAnimation("seeing",[5,5,6,7,8,9,8,7,6],20);
		play("normal");

		velocity.x=speed;
		//velocity.y=-120;





	}
	
	/*
	override public function create():Void
	{
	
		

	}
	*/
	

	override public function update():Void
	{
		super.update();

		if (velocity.x>0) {
			facing = FlxObject.LEFT;
		}
		else{
			facing = FlxObject.RIGHT;
		}
		if (mode==1) {
		      //rad  = sAngle * myPi;
			rad  = sAngle * (myPi* .00554);
			 if(vDir==1){
			   //y = oX + radius * Math.cos(rad);
			   velocity.y=(radius * Math.cos(rad));
			  }
			  else{
				  velocity.y =  - radius * Math.cos(rad);  
			  }
			 // y = oY + radius * Math.sin(rad);
			  sAngle += radSpeed; // clockwise

			  if(touching == 16||touching == 1){
				speed*=-1;
			  }
			  if(x+12>FlxG.width||x<0){
				speed*=-1;
			  }
			  velocity.x = speed;


		}
		else if (mode==2) {
			if (x>=parent.ourPlayer.x+6) {
				velocity.x = -speed;
			}
			else if (x<parent.ourPlayer.x-6) {
				velocity.x = speed;	
			}
			else{
				velocity.x=0;
			}

			if (y>=parent.ourPlayer.y+6) {
				velocity.y = -speed;
			}
			else if (y<parent.ourPlayer.y-6) {
				velocity.y = speed;	
			}
			else{
				velocity.y=0;
			}

		}
		else if (mode==3) {
			if (x>=parent.roboHead.x+3) {
				velocity.x = -speed;
			}
			else if (x<parent.roboHead.x-3) {
				velocity.x = speed;	
			}
			else{
				velocity.x=0;
			}

			if (y>=parent.roboHead.y+6) {
				velocity.y = -speed;
			}
			else if (y<parent.roboHead.y-6) {
				velocity.y = speed;	
			}
			else{
				velocity.y=0;
			}
		}




		if (y<4) {
			velocity.y*=1;
			y=5;
		}
		else if (y>FlxG.height-8){
			velocity.y*=1;
			y=FlxG.height-9;
		}



		//look for player or robotHead

		if (modeCoolDown==0){
			if (FlxU.getDistance(this.getMidpoint(),parent.ourPlayer.getMidpoint())<viewDist) {
				play("seeing");
				speed = 50;
				mode = 2;
				modeCoolDown=4;
			}
			else if (parent.ourPlayer.headless&&FlxU.getDistance(this.getMidpoint(),parent.roboHead.getMidpoint())<viewDist) {
				play("seeing");
				speed=50;
				mode = 3;
				modeCoolDown=2;	
			
			}
			else{
				if (mode!=1){
					play("normal");
					mode = 1;
					speed=45;
					modeCoolDown=2;
				}
			}
		}//end of modeCoolDown check
		else{
			if (shootCount%15==0&&shootCount<100&&mode!=1) {
				parent.enemyShoot(this);
			}
			if (modeCoolDown>0){
				modeCoolDown-=FlxG.elapsed;
				shootCount++;
			}
			else{
				modeCoolDown=0;
				shootCount=0;
			}
		}








	}

	public function hitLeftRight():Void{
			


	}
	
	
	

}