package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxBasic;
import org.flixel.FlxTilemap;
import org.flixel.FlxObject;
import nme.Assets;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Elastic;



class Level10 extends BaseLevel
{
	private var door1:Door;
	private var button1:Button;
	private var pU1:FlxSprite;
	
	
	
	override public function create():Void
	{
	

		backGround = new FlxSprite(0,0);
		backGround.alpha = .75;
		backGround.loadGraphic(FlxAssets.bgImage3,false,false,800,600);
		add(backGround);


		map = new FlxTilemap();
		map.loadMap(Assets.getText("assets/mapCSV_Group1_Level10.csv"),FlxAssets.tileImg3,20,20,FlxTilemap.OFF);
		add(map);
		super.create();
		var tacoRand:Float = FlxG.randomRange(3,1);
		//reput the taco
		taco.y=116;

		if (tacoRand==1) 
		{
			taco.x=326;
		}
		else {
			taco.x=446;
		}
	
		//taco.x=230;
		//taco.x = 328;
		//taco.x = 448;
		//taco.x = 548;
		//taco.alpha=.6;

		//place the player
		ourPlayer.x=160;
		ourPlayer.y=550;
		ourPlayer.facing = FlxObject.RIGHT;


		var platform:MPlatform1 = new MPlatform1(340,480);
		platform.velocity.x = -75;
		platform.startX=140;
		platform.travelDist=200;
		platformGroup.add(platform);

		var platform2:MPlatform1 = new MPlatform1(400,480);
		platform2.velocity.x = 75;
		platform2.travelDist=200;
		platformGroup.add(platform2);


		var platform3:MPlatform1 = new MPlatform1(340,300);
		platform3.velocity.x = -100;
		platform3.startX=90;
		platform3.travelDist=250;
		platformGroup.add(platform3);

		var platform4:MPlatform1 = new MPlatform1(400,300);
		platform4.velocity.x = 100;
		platform4.travelDist=250;
		platformGroup.add(platform4);


		var testEnemy1:Enemy1 = new Enemy1(205,115);
		enemyGroup.add(testEnemy1);

		var testEnemy2:Enemy1 = new Enemy1(220,115);
		enemyGroup.add(testEnemy2);

		var testEnemy3:Enemy1 = new Enemy1(240,115);
		enemyGroup.add(testEnemy3);


		var testEnemy4:Enemy1 = new Enemy1(305,115);
		enemyGroup.add(testEnemy4);

		var testEnemy5:Enemy1 = new Enemy1(320,115);
		enemyGroup.add(testEnemy5);

		var testEnemy6:Enemy1 = new Enemy1(340,115);
		enemyGroup.add(testEnemy6);

		var testEnemy7:Enemy1 = new Enemy1(420,115);
		enemyGroup.add(testEnemy7);

		var testEnemy8:Enemy1 = new Enemy1(435,115);
		enemyGroup.add(testEnemy8);

		var testEnemy9:Enemy1 = new Enemy1(455,115);
		enemyGroup.add(testEnemy9);


		var testEnemy10:Enemy1 = new Enemy1(525,115);
		enemyGroup.add(testEnemy10);

		var testEnemy11:Enemy1 = new Enemy1(540,115);
		enemyGroup.add(testEnemy11);

		var testEnemy12:Enemy1 = new Enemy1(555,115);
		enemyGroup.add(testEnemy12);

		var lTopH:Door = new Door(235,115,2);
		lTopH.makeHorz();
		doorGroup.add(lTopH);

		var l2TopH:Door = new Door(335,115);
		l2TopH.makeHorz();
		doorGroup.add(l2TopH);


		var rTopH:Door = new Door(455,115,2);
		rTopH.makeHorz();
		doorGroup.add(rTopH);

		var r2TopH:Door = new Door(555,115);
		r2TopH.makeHorz();
		doorGroup.add(r2TopH);


		var lMid:Door = new Door(65,420);
		doorGroup.add(lMid);

		var rMid:Door = new Door(725,420,2);
		doorGroup.add(rMid);

		var flyingEnemy:Enemy2 = new Enemy2(0,422,this);
		enemyGroup.add(flyingEnemy);

		var flyingEnemy2:Enemy2 = new Enemy2(35,416,this,2);
		enemyGroup.add(flyingEnemy2);


		var flyingEnemy3:Enemy2 = new Enemy2(760,422,this);
		enemyGroup.add(flyingEnemy3);

		var flyingEnemy4:Enemy2 = new Enemy2(780,416,this,2);
		enemyGroup.add(flyingEnemy4);


		var blueButton:Button = new Button(760,395,this);
		buttonGroup.add(blueButton);

		var redButton:Button = new Button(30,395,this,2);
		buttonGroup.add(redButton);

		stars.x = taco.x;
		stars.y = taco.y-6;
		stars.visible=false;

		//Power Up Section
		//add(powerUpGroup);
		//type of powerup, x location, chance of birth, time frame to birth
		powerUpTimer = haxe.Timer.delay(callback(createPowerUp,3,FlxG.randomRange2(600,200),1), FlxG.randomRange2(14000,7000));
		
	}


	override public function nextLevel():Void{
		powerUpTimer.stop();
		FlxG.switchState(new Level19());
	}

	override private function resetLevel():Void{
		powerUpTimer.stop();
 		 if (FlxAssets.gameMode==2) {
 		 	if (FlxAssets.hotLives==1) {
 		 		hotGameOver();
 		 	}
 		 	else{
 		 		FlxAssets.hotLives--;
 		 	 	FlxG.switchState(new Level10(2));
 		 	}
 		 }
 		 
 		 if (FlxAssets.gameMode==1) {
 		 	if (FlxAssets.tacoNum>1) {
 				FlxAssets.tacoNum--;
 		 	}
 		 	 FlxG.switchState(new Level10(2));
 		}
 	}
	

	override private function buttonHit(b:Button,r:FlxSprite):Void{
			taco.alpha=1;
			if(b.touching == FlxObject.UP){
				b.buttonDown();
				openDoors(b.type);
			}
			if(b.touching==FlxObject.RIGHT||b.touching==FlxObject.LEFT){
				r.y-=4;
			}
	}


	

	
	override public function update():Void
	{
		super.update();
		FlxG.collide(doorGroup,robotGroup);
		FlxG.collide(buttonGroup,robotGroup,buttonHit);
		FlxG.collide(enemyGroup,map);
		FlxG.collide(enemyGroup,doorGroup);
		FlxG.overlap(ourPlayer,enviroGroup,enviroHit);
		FlxG.overlap(robotGroup,enviroGroup,enviroHit);
		FlxG.collide(lazerGroup,powerUGroup,explodePowerU);
		FlxG.collide(lazerGroup,enemyGroup,enemyHit);
		FlxG.collide(lazerGroup,map,mapZap);

		FlxG.collide(lazerGroup,doorGroup,basicZap);

		FlxG.collide(robotGroup,platformGroup);
		FlxG.collide(enemyGroup,platformGroup);

		//spitter stuff
		FlxG.collide(spitGroup,map,mapSpit);
		FlxG.collide(spitGroup,platformGroup,spitExplode);
		FlxG.collide(spitGroup,robotGroup,spitHit);
		FlxG.collide(spitGroup,ourPlayer,spitHit);

		FlxG.collide(robotGroup,powerUpGroup,hitPowerUP);
		FlxG.collide(ourPlayer,powerUpGroup,hitPowerUP);

		updateParts();


	}//end of update

	

	

}